<?php

	// Perform Login
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Check array size
	PHPCUS_PARAM::CUS_ARRAY_TOO_LARGE();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_EDIT, 'category_company');
	
	if
	(
			PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
			(
					[
							'PARAM_CAT_COMPANY_ID',
							'PARAM_CAT_COMPANY_CODE', 
							'PARAM_CAT_COMPANY_DESCRIPTION', 
							'PARAM_CAT_COMPANY_TIN', 
							'PARAM_CAT_COMPANY_ADDRESS', 
							'PARAM_CAT_COMPANY_MOBILE', 
							'PARAM_CAT_COMPANY_PHONE', 
							'PARAM_CAT_COMPANY_FAX', 
							'PARAM_CAT_COMPANY_EMAIL', 
							'PARAM_CAT_COMPANY_WEBSITE', 
							'PARAM_CAT_COMPANY_SNS_PAGE', 
							'PARAM_CAT_COMPANY_CAT_COMPANY_TYPE_ID', 
							'PARAM_CAT_COMPANY_REMARKS', 
							'PARAM_CAT_COMPANY_STATUS'
							// , 'PARAM_CAT_COMPANY_ID_FILE'
					], True
			)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------
			$PARAM_CAT_COMPANY_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_COMPANY_ID', true);
			$PARAM_CAT_COMPANY_CODE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_CODE', true);
			$PARAM_CAT_COMPANY_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_DESCRIPTION', true);
			$PARAM_CAT_COMPANY_TIN = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_TIN', true);
			$PARAM_CAT_COMPANY_ADDRESS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_ADDRESS', true);
			$PARAM_CAT_COMPANY_MOBILE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_MOBILE', true);
			$PARAM_CAT_COMPANY_PHONE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_PHONE', true);
			$PARAM_CAT_COMPANY_FAX = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_FAX', true);
			$PARAM_CAT_COMPANY_EMAIL = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_EMAIL', true);
			$PARAM_CAT_COMPANY_WEBSITE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_WEBSITE', true);
			$PARAM_CAT_COMPANY_SNS_PAGE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_SNS_PAGE', true);
			$PARAM_CAT_COMPANY_CAT_COMPANY_TYPE_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_CAT_COMPANY_CAT_COMPANY_TYPE_ID', true);
			$PARAM_CAT_COMPANY_REMARKS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_CAT_COMPANY_REMARKS', true);
			$PARAM_CAT_COMPANY_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_CAT_COMPANY_STATUS', true);
			
			//$PARAM_CAT_COMPANY_ID_FILE = PHPCUS_PARAM::CUS_READ_FILES('PARAM_CAT_COMPANY_ID_FILE');
			$PARAM_ARRAY_COUNT = count($PARAM_CAT_COMPANY_ID);
			
				
			// Validate if array has same size
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_ARRAY_SIZE_MISMATCH
			(
					[
							$PARAM_CAT_COMPANY_ID,
							$PARAM_CAT_COMPANY_CODE, 
							$PARAM_CAT_COMPANY_DESCRIPTION, 
							$PARAM_CAT_COMPANY_TIN, 
							$PARAM_CAT_COMPANY_ADDRESS, 
							$PARAM_CAT_COMPANY_MOBILE, 
							$PARAM_CAT_COMPANY_PHONE, 
							$PARAM_CAT_COMPANY_FAX, 
							$PARAM_CAT_COMPANY_EMAIL, 
							$PARAM_CAT_COMPANY_WEBSITE, 
							$PARAM_CAT_COMPANY_SNS_PAGE, 
							$PARAM_CAT_COMPANY_CAT_COMPANY_TYPE_ID, 
							$PARAM_CAT_COMPANY_REMARKS, 
							$PARAM_CAT_COMPANY_STATUS
							// ,$PARAM_CAT_COMPANY_ID_FILE['name']
					]
			);
			
				
			// Prepare PDO Handler
			// ------------------------------------------------------------------
			$FULL_DATA_SET = [];
			$ARRAY_CTR = 0;
			
			$SAVE_MAP_ARRAY = [];
			$PDO_HANDLE = PHPRC_PDO_MYSQL::REF_CONNECT();
			PHPRC_PDO_MYSQL::REF_TRANSACTION_BEGIN($PDO_HANDLE);
			
		
			// Execute Stored Procedure
			// ------------------------------------------------------------------
			Try
			{
				while($ARRAY_CTR < $PARAM_ARRAY_COUNT)
				{
					$SAVE_MAP_ARRAY = PHPCUS_CATEGORY_COMPANY::CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
					
					$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_ID'] = $PARAM_CAT_COMPANY_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_CODE'] = $PARAM_CAT_COMPANY_CODE[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_DESCRIPTION'] = $PARAM_CAT_COMPANY_DESCRIPTION[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_TIN'] = $PARAM_CAT_COMPANY_TIN[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_ADDRESS'] = $PARAM_CAT_COMPANY_ADDRESS[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_MOBILE'] = $PARAM_CAT_COMPANY_MOBILE[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_PHONE'] = $PARAM_CAT_COMPANY_PHONE[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_FAX'] = $PARAM_CAT_COMPANY_FAX[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_EMAIL'] = $PARAM_CAT_COMPANY_EMAIL[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_WEBSITE'] = $PARAM_CAT_COMPANY_WEBSITE[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_SNS_PAGE'] = $PARAM_CAT_COMPANY_SNS_PAGE[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_CAT_COMPANY_TYPE_ID'] = $PARAM_CAT_COMPANY_CAT_COMPANY_TYPE_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_REMARKS'] = $PARAM_CAT_COMPANY_REMARKS[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_CAT_COMPANY_STATUS'] = $PARAM_CAT_COMPANY_STATUS[$ARRAY_CTR];
							
					$DATA_SET = PHPCUS_CATEGORY_COMPANY::CUS_SAVE_MA
					(
							$SAVE_MAP_ARRAY,
							true,
							$PDO_HANDLE
					);
			
					/*
					if
					(
						isset($PARAM_REC_FILEDIR_ID_FILE['name'][$ARRAY_CTR]) && 
						empty($DATA_SET) == false && 
						isset($DATA_SET[0]['INSERTED_ID'])
					)
					{		
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Category');
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Category/company');
						PHPRC_FSO_DIRECTORY::REF_CREATE(PHPSET::$ROOT . '/upload/priv/Category/company/' .  floor($DATA_SET[0]['INSERTED_ID'] / 5000));
					
						PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_MOVEFILE
						(
							$PARAM_CAT_COMPANY_ID_FILE['tmp_name'][$ARRAY_CTR],
							PHPSET::$ROOT . '/upload/priv/Category/company/' .  floor($DATA_SET[0]['INSERTED_ID'] / 5000) . '/' . $DATA_SET[0]['INSERTED_ID'] . '.' .
							PHPVC_STR::VAR_LCASE(PathInfo($PARAM_CAT_COMPANY_ID_FILE['name'][$ARRAY_CTR], PATHINFO_EXTENSION))
						);
					}
					*/
					
					$FULL_DATA_SET = PHPRC_PDO_MYSQL_ARRAY::REF_MERGE($FULL_DATA_SET, $DATA_SET);
					$ARRAY_CTR ++;
				}
					
			}
			Catch(Exception $PDO_ERR)
			{
				PHPRC_PDO_MYSQL::REF_TRANSACTION_ROLLBACK($PDO_HANDLE);
				//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_ROLLBACK();
				PHPCUS_PARAM::CUS_JSON_ERROR($PDO_ERR);
			}
			PHPRC_PDO_MYSQL::REF_TRANSACTION_COMMIT($PDO_HANDLE);
			//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_COMMIT();
						
			
			
			// Return JSON response
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_JSON_SUCCESS($FULL_DATA_SET);
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR);
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>